Debian Bug report logs - #561046
RFP: gcc-4.5-cross -- GNU Compiler Collection cross compilers (C, C++) for armel architecture

Package: wnpp; Maintainer for wnpp is wnpp@debian.org;

Reported by: Nicolas Dandrimont <nicolas.dandrimont@crans.org>

Date: Mon, 14 Dec 2009 00:09:11 UTC

Severity: wishlist

Merged with 590465

Reply or subscribe to this bug.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, debian-devel@lists.debian.org, <wnpp@debian.org>:
Bug#561046; Package wnpp. (Mon, 14 Dec 2009 00:09:15 GMT) Full text and rfc822 format available.

Acknowledgement sent to Nicolas Dandrimont <nicolas.dandrimont@crans.org>:
New Bug report received and forwarded. Copy sent to debian-devel@lists.debian.org, <wnpp@debian.org>. (Mon, 14 Dec 2009 00:09:15 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Nicolas Dandrimont <nicolas.dandrimont@crans.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: ITP: gcc-arm -- The GNU C Compiler (cross-compiler for ARM targets)
Date: Mon, 14 Dec 2009 00:52:26 +0100
Package: wnpp
Severity: wishlist
Owner: Nicolas Dandrimont <nicolas.dandrimont@crans.org>

* Package name    : gcc-arm
  Version         : 4.4.2
  Upstream Author : Numerous (see gcc-4.4-source package)
* URL             : http://gcc.gnu.org/
* License         : GPL3 (+ exception for runtime library)
  Programming Lang: C
  Description     : The GNU C Compiler (cross-compiler for ARM targets)

This is the GNU C compiler, a fairly portable optimizing compiler
which supports multiple languages.
 
This package includes support for C and C++ on arm-none-eabi targets.

---

This package will be built using the gcc-4.4-source package, in a
manner analogous to what is done for gcc-avr.

It will Build-Depend on newlib-arm so as to be able to build the C++
compiler. This makes a loop-Build-Dependency, but as newlib-arm will
be an Arch-independent package it shouldn't pose a bootstrap problem.




Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, Nicolas Dandrimont <nicolas.dandrimont@crans.org>:
Bug#561046; Package wnpp. (Mon, 14 Dec 2009 01:06:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to Hector Oron <hector.oron@gmail.com>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, Nicolas Dandrimont <nicolas.dandrimont@crans.org>. (Mon, 14 Dec 2009 01:06:08 GMT) Full text and rfc822 format available.

Message #10 received at 561046@bugs.debian.org (full text, mbox):

From: Hector Oron <hector.oron@gmail.com>
To: Nicolas Dandrimont <nicolas.dandrimont@crans.org>, 561046@bugs.debian.org, 561045@bugs.debian.org, 561044@bugs.debian.org, 561043@bugs.debian.org
Cc: debian embedded <debian-embedded@lists.debian.org>
Subject: Re: Bug#561046: ITP: gcc-arm -- The GNU C Compiler (cross-compiler for ARM targets)
Date: Mon, 14 Dec 2009 02:04:41 +0100
Hello Nicolas,

2009/12/14 Nicolas Dandrimont <nicolas.dandrimont@crans.org>:
> * Package name    : gcc-arm
>  Version         : 4.4.2
>  Upstream Author : Numerous (see gcc-4.4-source package)

  The cross compiler set can be built (in a different variant from
yours) from gcc and friends package sources. Emdebian.org has been
providing this sets for a while.

  A similar ITP was filled (in case you were not aware) a while back,
#553685, #553687, #553684, #553683, #553682, #553679.

 In order to keep GPL compliant, dak needs to be taught (if not
already) how to keep -source build-deps arround for autobuilders.

  If you are interested on this topic I highly recommend you to join
debian-embedded@l.d.o, have a look to CategoryEmdebian at wiki.d.o and
join #emdebian/irc.debian.org.

  This group (debian-embedded) is working towards a nicer integration
of tools within a framework easing embedded development.

  Exotic cross compilers are planned to be kept out of debian, most
likely debian-ports.org or emdebian.org

  Kind regards,
-- 
 Héctor Orón

"Our Sun unleashes tremendous flares expelling hot gas into the Solar
System, which one day will disconnect us."




Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>:
Bug#561046; Package wnpp. (Mon, 14 Dec 2009 02:15:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to Nicolas Dandrimont <nicolas.dandrimont@crans.org>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>. (Mon, 14 Dec 2009 02:15:08 GMT) Full text and rfc822 format available.

Message #15 received at 561046@bugs.debian.org (full text, mbox):

From: Nicolas Dandrimont <nicolas.dandrimont@crans.org>
To: Hector Oron <hector.oron@gmail.com>, Matthias Klose <doko@debian.org>
Cc: 561046@bugs.debian.org, 561045@bugs.debian.org, 561044@bugs.debian.org, 561043@bugs.debian.org, Debian Embedded <debian-embedded@lists.debian.org>
Subject: Re: Bug#561046: ITP: gcc-arm -- The GNU C Compiler (cross-compiler for ARM targets)
Date: Mon, 14 Dec 2009 03:01:00 +0100
[Message part 1 (text/plain, inline)]
Hi Hector, Matthias and debian-embedded team,

Replying to Hector's email should also address Matthias' concerns, so
here goes:

* Hector Oron <hector.oron@gmail.com> [2009-12-14 02:04:41 +0100]:

> Hello Nicolas,
> 
> 2009/12/14 Nicolas Dandrimont <nicolas.dandrimont@crans.org>:
> > * Package name    : gcc-arm
> >  Version         : 4.4.2
> >  Upstream Author : Numerous (see gcc-4.4-source package)
> 
>   The cross compiler set can be built (in a different variant from
> yours) from gcc and friends package sources. Emdebian.org has been
> providing this sets for a while.
>
>   A similar ITP was filled (in case you were not aware) a while back,
> #553685, #553687, #553684, #553683, #553682, #553679.

Emdebian seems to focus on embedded Linux targets. However, the
packages I am currently making aim at raw targets (well,
`arm-none-eabi' instead of `arm-linux-gnueabi'). This toolchain would
be an equivalent of the current *-avr toolchain, but for ARM
chips. Maybe the name and description of the packages I intend to make
should be made clearer.

>  In order to keep GPL compliant, dak needs to be taught (if not
> already) how to keep -source build-deps arround for autobuilders.

Hmm. This is a problem I read about but I totally forgot. I re-read
the 'Bits from the FTPMaster meeting'[1], in which Joerg says that
work is underway, but I can't seem to find any bug-report (well, on
the `ftp.debian.org' pseudopackage) keeping track of progress on this
matter.

[1] http://lists.debian.org/debian-devel-announce/2009/11/msg00001.html

>   If you are interested on this topic I highly recommend you to join
> debian-embedded@l.d.o, have a look to CategoryEmdebian at wiki.d.o and
> join #emdebian/irc.debian.org.
> 
>   This group (debian-embedded) is working towards a nicer integration
> of tools within a framework easing embedded development.
> 
>   Exotic cross compilers are planned to be kept out of debian, most
> likely debian-ports.org or emdebian.org

I already had a look at the Emdebian documentation, but as it focused
on either porting Debian or cross-compiling specifically for Linux
targets, I went ahead and filed those ITPs for the main debian
archive. I was comforted by the presence of the avr toolchain in main.

Indeed, if you think emdebian is the right place for those packages,
I'll be happy to maintain them under its umbrella.

Thank you for your interest,
-- 
Nicolas Dandrimont

NB: I'm subscribed to the debian-embedded@l.d.o mailing list, so no
need to Cc: me back on replies to the list.

"...Deep Hack Mode--that mysterious and frightening state of
consciousness where Mortal Users fear to tread."
(By Matt Welsh)
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, Nicolas Dandrimont <nicolas.dandrimont@crans.org>:
Bug#561046; Package wnpp. (Mon, 14 Dec 2009 11:51:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to hector.oron@gmail.com:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, Nicolas Dandrimont <nicolas.dandrimont@crans.org>. (Mon, 14 Dec 2009 11:51:02 GMT) Full text and rfc822 format available.

Message #20 received at 561046@bugs.debian.org (full text, mbox):

From: hector.oron@gmail.com
To: Nicolas Dandrimont <nicolas.dandrimont@crans.org>
Cc: Matthias Klose <doko@debian.org>, 561046@bugs.debian.org, 561045-silent@bugs.debian.org, 561044-silent@bugs.debian.org, 561043-silent@bugs.debian.org, Debian Embedded <debian-embedded@lists.debian.org>
Subject: Re: Bug#561046: ITP: gcc-arm -- The GNU C Compiler (cross-compiler for ARM targets)
Date: Mon, 14 Dec 2009 13:49:11 +0100 (CET)
[Message part 1 (text/plain, inline)]
Hello Nicolas,

2009/12/14 Nicolas Dandrimont <nicolas.dandrimont@crans.org>:
> Emdebian seems to focus on embedded Linux targets. However, the
> packages I am currently making aim at raw targets (well,
> `arm-none-eabi' instead of `arm-linux-gnueabi'). This toolchain would
> be an equivalent of the current *-avr toolchain, but for ARM
> chips. Maybe the name and description of the packages I intend to make
> should be made clearer.

How 'arm-none-eabi' differ from 'arm-linux-gnueabi' besides C library? Can 'arm-linux-gnueabi' be used in most 'arm-none-eabi' use cases? Are you thinking on using sysroot for this tool (multiarch orthogonal)? Do you have a plan to integrate libraries and headers someway (we use dpkg-cross for this) or is this similar to 'none header compiler' (first bootstrap compiler)?

> I already had a look at the Emdebian documentation, but as it focused
> on either porting Debian or cross-compiling specifically for Linux
> targets, I went ahead and filed those ITPs for the main debian
> archive. I was comforted by the presence of the avr toolchain in main.

Emdebian is a group of people. This group tries to dignify Debian to be used for embedded targets (not fork, nor port). There are many tools (scratchbox, qemu, cross toolchains, apt-cross, dpkg-cross, emdebian-{tools, rootfs, grip, *}) emdebian people is working on.

Currently, avr, mingw32 and z80 tools (maybe some others) are in the main archive, but those were uploaded without any coherence in mind (afaict) and these tools might need to be adapted to newer layouts (see multiarch[1][2] or upstream sysroot -which depends on modifying dpkg-cross-) or removed from the archive. 

We also should *keep in mind not to polute Debian main with a bunch of crossgcc-tools* for each individual case (which could grow up to hundreds different configurations) but to have a distribution crosstoolchain (built in most cases and when possible with Debian defaults)

> Indeed, if you think emdebian is the right place for those packages,
> I'll be happy to maintain them under its umbrella.

All those packages, but newlib, are already packaged [3][4] in two different ways and a third one might arise. Do you also have them packaged? If you already have them packaged, please submit your packaging in you want comments on them.

Tomorrow, there is an IRC meeting[5] which you are invited to, in case you want to participate.

[1] http://www.ubuntu.org/MultiarchSpec
[2] http://www.ubuntu.org/MultiarchCross
[3] see README.Cross in binutils and gcc packages
[4] http://emdebian.org/git/buildcross.git || https://launchpad.net/~lool/+archive/ppa
[5] http://wiki.debian.org/Emdebian/Meetings

-- 
Héctor Orón

"Our Sun unleashes tremendous flares expelling hot gas into the Solar System, which one day will disconnect us."


[signature.asc (application/pgp-signature, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, Nicolas Dandrimont <nicolas.dandrimont@crans.org>:
Bug#561046; Package wnpp. (Mon, 14 Dec 2009 12:27:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Simon Richter <sjr@debian.org>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, Nicolas Dandrimont <nicolas.dandrimont@crans.org>. (Mon, 14 Dec 2009 12:27:04 GMT) Full text and rfc822 format available.

Message #25 received at 561046@bugs.debian.org (full text, mbox):

From: Simon Richter <sjr@debian.org>
To: hector.oron@gmail.com
Cc: Nicolas Dandrimont <nicolas.dandrimont@crans.org>, Matthias Klose <doko@debian.org>, 561046@bugs.debian.org, 561045-silent@bugs.debian.org, 561044-silent@bugs.debian.org, 561043-silent@bugs.debian.org, Debian Embedded <debian-embedded@lists.debian.org>
Subject: Re: Bug#561046: ITP: gcc-arm -- The GNU C Compiler (cross-compiler for ARM targets)
Date: Mon, 14 Dec 2009 13:17:38 +0100
Hi,

On Mon, Dec 14, 2009 at 01:49:11PM +0100, hector.oron@gmail.com wrote:

> How 'arm-none-eabi' differ from 'arm-linux-gnueabi' besides C library?

Not at all.

> Can 'arm-linux-gnueabi' be used in most 'arm-none-eabi' use cases?

Yes. I just built a firmware file for an embedded device using the
emdebian compiler, and it works fine.

   Simon




Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, Nicolas Dandrimont <nicolas.dandrimont@crans.org>:
Bug#561046; Package wnpp. (Mon, 14 Dec 2009 13:33:10 GMT) Full text and rfc822 format available.

Acknowledgement sent to Bill Gatliff <bgat@billgatliff.com>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, Nicolas Dandrimont <nicolas.dandrimont@crans.org>. (Mon, 14 Dec 2009 13:33:10 GMT) Full text and rfc822 format available.

Message #30 received at 561046@bugs.debian.org (full text, mbox):

From: Bill Gatliff <bgat@billgatliff.com>
To: Nicolas Dandrimont <nicolas.dandrimont@crans.org>
Cc: Hector Oron <hector.oron@gmail.com>, Matthias Klose <doko@debian.org>, 561046@bugs.debian.org, 561045@bugs.debian.org, 561044@bugs.debian.org, 561043@bugs.debian.org, Debian Embedded <debian-embedded@lists.debian.org>
Subject: Re: Bug#561046: ITP: gcc-arm -- The GNU C Compiler (cross-compiler for ARM targets)
Date: Mon, 14 Dec 2009 07:30:14 -0600
Nicolas Dandrimont wrote:
> I already had a look at the Emdebian documentation, but as it focused
> on either porting Debian or cross-compiling specifically for Linux
> targets, I went ahead and filed those ITPs for the main debian
> archive. I was comforted by the presence of the avr toolchain in main.
>
> Indeed, if you think emdebian is the right place for those packages,
> I'll be happy to maintain them under its umbrella.
>   

I don't think that emdebian is the right direction for your package,
although there are certainly many parallels to what they are trying to
do.  The approach used by the AVR toolchain is more seems more appropriate.

What are your plans for a runtime library?  Newlib might be a good
choice, since there are already source and HC11 packages.  I haven't
looked at the details of the avr-libc package to see what they are doing.

Finally, you might should specify whether you are "binutils-armel" or
"binutils-armeb" instead of the more generic "binutils-arm", since the
latter architecture was deprecated for Debian.


b.g.

-- 
Bill Gatliff
bgat@billgatliff.com





Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, Nicolas Dandrimont <nicolas.dandrimont@crans.org>:
Bug#561046; Package wnpp. (Mon, 14 Dec 2009 13:45:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Bill Gatliff <bgat@billgatliff.com>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, Nicolas Dandrimont <nicolas.dandrimont@crans.org>. (Mon, 14 Dec 2009 13:45:03 GMT) Full text and rfc822 format available.

Message #35 received at 561046@bugs.debian.org (full text, mbox):

From: Bill Gatliff <bgat@billgatliff.com>
To: hector.oron@gmail.com
Cc: Nicolas Dandrimont <nicolas.dandrimont@crans.org>, Matthias Klose <doko@debian.org>, 561046@bugs.debian.org, 561045-silent@bugs.debian.org, 561044-silent@bugs.debian.org, 561043-silent@bugs.debian.org, Debian Embedded <debian-embedded@lists.debian.org>
Subject: Re: Bug#561046: ITP: gcc-arm -- The GNU C Compiler (cross-compiler for ARM targets)
Date: Mon, 14 Dec 2009 07:42:35 -0600
hector.oron@gmail.com wrote:
>
> How 'arm-none-eabi' differ from 'arm-linux-gnueabi' besides C library?
> Can 'arm-linux-gnueabi' be used in most 'arm-none-eabi' use cases?

It is technically possible to use an arm-linux toolchain where one would
normally use an arm-none toolchain.  But there are subtle differences
between the two at the library interface level, I have found that the
*-linux toolchain tends to depend on library functions that bare-metal
systems often don't have.

It's also a matter of clarity for developers.  "Why would I want a
*-linux toolchain, I'm not building for a Linux target".


> Emdebian is a group of people. This group tries to dignify Debian to
> be used for embedded targets (not fork, nor port). There are many
> tools (scratchbox, qemu, cross toolchains, apt-cross, dpkg-cross,
> emdebian-{tools, rootfs, grip, *}) emdebian people is working on.

Yes, and they are all fabulous.  Particularly if you are trying to
manage Debian in cross-platform environments.  But they aren't
particularly optimal for what the OP is trying to accomplish, which is
to produce a toolchain that can be used as a starting point for a
bare-metal application.

> Currently, avr, mingw32 and z80 tools (maybe some others) are in the
> main archive, but those were uploaded without any coherence in mind
> (afaict) and these tools might need to be adapted to newer layouts
> (see multiarch[1][2] or upstream sysroot -which depends on modifying
> dpkg-cross-) or removed from the archive.
> We also should *keep in mind not to polute Debian main with a bunch of
> crossgcc-tools* for each individual case (which could grow up to
> hundreds different configurations) but to have a distribution
> crosstoolchain (built in most cases and when possible with Debian
> defaults)

I like the idea of having cross toolchain packages that are "sociable"
with the Debian system.  However, that really isn't a consideration for
a binutils-arm-none toolchain: its work products are by definition not
compatible with Debian--- or even Linux.  So the concerns for this
situation come down to making sure that his packaging approach is
consistent with other Debian packages for non-Debian toolchains, AFAICT.


b.g.

-- 
Bill Gatliff
bgat@billgatliff.com





Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, Nicolas Dandrimont <nicolas.dandrimont@crans.org>:
Bug#561046; Package wnpp. (Mon, 14 Dec 2009 14:21:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Hector Oron <hector.oron@gmail.com>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, Nicolas Dandrimont <nicolas.dandrimont@crans.org>. (Mon, 14 Dec 2009 14:21:09 GMT) Full text and rfc822 format available.

Message #40 received at 561046@bugs.debian.org (full text, mbox):

From: Hector Oron <hector.oron@gmail.com>
To: Bill Gatliff <bgat@billgatliff.com>
Cc: Nicolas Dandrimont <nicolas.dandrimont@crans.org>, Matthias Klose <doko@debian.org>, 561046@bugs.debian.org, 561045@bugs.debian.org, 561044@bugs.debian.org, 561043@bugs.debian.org, Debian Embedded <debian-embedded@lists.debian.org>
Subject: Re: Bug#561046: ITP: gcc-arm -- The GNU C Compiler (cross-compiler for ARM targets)
Date: Mon, 14 Dec 2009 15:18:33 +0100
Hello,

2009/12/14 Bill Gatliff <bgat@billgatliff.com>:
>> How 'arm-none-eabi' differ from 'arm-linux-gnueabi' besides C library?
>> Can 'arm-linux-gnueabi' be used in most 'arm-none-eabi' use cases?
>
> It is technically possible to use an arm-linux toolchain where one would
> normally use an arm-none toolchain.  But there are subtle differences
> between the two at the library interface level, I have found that the
> *-linux toolchain tends to depend on library functions that bare-metal
> systems often don't have.
>
> It's also a matter of clarity for developers.  "Why would I want a
> *-linux toolchain, I'm not building for a Linux target".

But if technically speaking, they both offer same resources for
developers, it does not make me any sense to duplicate the archive.

>> Emdebian is a group of people. This group tries to dignify Debian to
>> be used for embedded targets (not fork, nor port). There are many
>> tools (scratchbox, qemu, cross toolchains, apt-cross, dpkg-cross,
>> emdebian-{tools, rootfs, grip, *}) emdebian people is working on.
>
> Yes, and they are all fabulous.  Particularly if you are trying to
> manage Debian in cross-platform environments.  But they aren't
> particularly optimal for what the OP is trying to accomplish, which is
> to produce a toolchain that can be used as a starting point for a
> bare-metal application.

This is like a first stage toolchain, which it is in the toolchain
roadmap (as bootstrapping toolchain). Then we can have eglibc, uclibc
or other C libraries based toolchains.

> I like the idea of having cross toolchain packages that are "sociable"
> with the Debian system.  However, that really isn't a consideration for
> a binutils-arm-none toolchain: its work products are by definition not
> compatible with Debian--- or even Linux.  So the concerns for this
> situation come down to making sure that his packaging approach is
> consistent with other Debian packages for non-Debian toolchains, AFAICT.

I think I missed this point on binutils-arm-none. But binutils does
not depend on linux nor C library. binutils-armel can be shared among
(eglibc,uclibc,newlib,...) toolchains.

-- 
 Héctor Orón

"Our Sun unleashes tremendous flares expelling hot gas into the Solar
System, which one day will disconnect us."




Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, Nicolas Dandrimont <nicolas.dandrimont@crans.org>:
Bug#561046; Package wnpp. (Mon, 14 Dec 2009 14:48:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ron <ron@debian.org>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, Nicolas Dandrimont <nicolas.dandrimont@crans.org>. (Mon, 14 Dec 2009 14:48:05 GMT) Full text and rfc822 format available.

Message #45 received at 561046@bugs.debian.org (full text, mbox):

From: Ron <ron@debian.org>
To: Bill Gatliff <bgat@billgatliff.com>
Cc: hector.oron@gmail.com, Nicolas Dandrimont <nicolas.dandrimont@crans.org>, Matthias Klose <doko@debian.org>, 561046@bugs.debian.org, 561045-silent@bugs.debian.org, 561044-silent@bugs.debian.org, 561043-silent@bugs.debian.org, Debian Embedded <debian-embedded@lists.debian.org>
Subject: Re: Bug#561046: ITP: gcc-arm -- The GNU C Compiler (cross-compiler for ARM targets)
Date: Tue, 15 Dec 2009 01:05:50 +1030
On Mon, Dec 14, 2009 at 07:42:35AM -0600, Bill Gatliff wrote:
> hector.oron@gmail.com wrote:
> >
> > How 'arm-none-eabi' differ from 'arm-linux-gnueabi' besides C library?
> > Can 'arm-linux-gnueabi' be used in most 'arm-none-eabi' use cases?
> 
> It is technically possible to use an arm-linux toolchain where one would
> normally use an arm-none toolchain.  But there are subtle differences
> between the two at the library interface level, I have found that the
> *-linux toolchain tends to depend on library functions that bare-metal
> systems often don't have.

Which library functions?

I've been using toolchains built for both uclibc systems and for
Debian glibc to build bare firmware for armv4t for years now without
any trouble.  It has no OS, no libc or other support, and this has
never been a problem at all.

I don't see why the toolchain would ever drag in a 'library function'
that you didn't explicitly ask it for.  That's not its job, or how
it works.

> It's also a matter of clarity for developers.  "Why would I want a
> *-linux toolchain, I'm not building for a Linux target".

"Why would you want to suggest to people they need 2 toolchains
when they probably only need one?"

This seems like a rather wasteful and deceptive 'clarity' to me ...

I think the current cross compilers already in the main distro should
be seen as an aberration, not a sign of best practice.  There are far
too many possible permutations to build and distribute them all.
We need a much more scalable solution than just piling them all in
one at a time as one or two users find a need for each of them.

> Yes, and they are all fabulous.  Particularly if you are trying to
> manage Debian in cross-platform environments.  But they aren't
> particularly optimal for what the OP is trying to accomplish, which is
> to produce a toolchain that can be used as a starting point for a
> bare-metal application.

Some evidence that is true would make it a more compelling point.

> I like the idea of having cross toolchain packages that are "sociable"
> with the Debian system.  However, that really isn't a consideration for
> a binutils-arm-none toolchain: its work products are by definition not
> compatible with Debian--- or even Linux.  So the concerns for this
> situation come down to making sure that his packaging approach is
> consistent with other Debian packages for non-Debian toolchains, AFAICT.

Or maybe the concern is "do things that aren't compatible with Debian
belong in Debian at all"?  But I don't really see that as being an issue
here at all.  The toolchain won't bring in anything from Debian that you
didn't ask it to.  If all you want is a different name, you can probably
just do that with some symlinks, but I don't personally see any advantage
to doing that either.

Cheers,
Ron






Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org, Nicolas Dandrimont <nicolas.dandrimont@crans.org>:
Bug#561046; Package wnpp. (Mon, 26 Jul 2010 14:39:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Chris Baines <cbaines8@gmail.com>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org, Nicolas Dandrimont <nicolas.dandrimont@crans.org>. (Mon, 26 Jul 2010 14:39:03 GMT) Full text and rfc822 format available.

Message #50 received at 561046@bugs.debian.org (full text, mbox):

From: Chris Baines <cbaines8@gmail.com>
To: 561046@bugs.debian.org
Date: Mon, 26 Jul 2010 15:36:22 +0100
Hello,

I have a couple of questions I was hoping you can answer, this bug has
been around for a few months now, are you still planning to package
this? I am working on a package that currently needs the arm-elf
toolchain with interwork and softfloat support compiled with gcc 4.3.x
does this package support some or all of this?

Thanks,

Chris





Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org, Nicolas Dandrimont <nicolas.dandrimont@crans.org>:
Bug#561046; Package wnpp. (Sat, 19 Feb 2011 17:18:53 GMT) Full text and rfc822 format available.

Acknowledgement sent to Lucas Nussbaum <lucas@debian.org>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org, Nicolas Dandrimont <nicolas.dandrimont@crans.org>. (Sat, 19 Feb 2011 17:18:53 GMT) Full text and rfc822 format available.

Message #55 received at 561046@bugs.debian.org (full text, mbox):

From: Lucas Nussbaum <lucas@debian.org>
To: 561046@bugs.debian.org
Cc: control@bugs.debian.org
Subject: gcc-arm: changing back from ITP to RFP
Date: Sat, 19 Feb 2011 17:06:47 +0000
retitle 561046 RFP: gcc-arm -- The GNU C Compiler (cross-compiler for ARM targets)
noowner 561046
thanks

Hi,

This is an automatic email to change the status of gcc-arm back from ITP
(Intent to Package) to RFP (Request for Package), because this bug hasn't seen
any activity during the last 6 months.

If you are still interested in adopting gcc-arm, please send a mail to
<control@bugs.debian.org> with:

 retitle 561046 ITP: gcc-arm -- The GNU C Compiler (cross-compiler for ARM targets)
 owner 561046 !
 thanks

However, it is not recommended to keep ITP for a long time without acting on
the package, as it might cause other prospective maintainers to refrain from
packaging that software. It is also a good idea to document your progress on
this ITP from time to time, by mailing <561046@bugs.debian.org>.

Thank you for your interest in Debian,
-- 
Lucas, for the QA team <debian-qa@lists.debian.org>




Changed Bug title to 'RFP: gcc-arm -- The GNU C Compiler (cross-compiler for ARM targets)' from 'ITP: gcc-arm -- The GNU C Compiler (cross-compiler for ARM targets)' Request was from Lucas Nussbaum <lucas@debian.org> to control@bugs.debian.org. (Sat, 19 Feb 2011 17:21:01 GMT) Full text and rfc822 format available.

Removed annotation that Bug was owned by Nicolas Dandrimont <nicolas.dandrimont@crans.org>. Request was from Lucas Nussbaum <lucas@debian.org> to control@bugs.debian.org. (Sat, 19 Feb 2011 17:21:02 GMT) Full text and rfc822 format available.

Owner recorded as hector.oron@gmail.com. Request was from Hector Oron <zumbi@debian.org> to control@bugs.debian.org. (Wed, 13 Jul 2011 12:51:21 GMT) Full text and rfc822 format available.

Merged 561046 590465. Request was from Hector Oron <zumbi@debian.org> to control@bugs.debian.org. (Wed, 13 Jul 2011 12:51:26 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org, hector.oron@gmail.com:
Bug#561046; Package wnpp. (Wed, 29 Feb 2012 18:51:10 GMT) Full text and rfc822 format available.

Acknowledgement sent to Johannes Schauer <j.schauer@email.de>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org, hector.oron@gmail.com. (Wed, 29 Feb 2012 18:51:11 GMT) Full text and rfc822 format available.

Message #68 received at 561046@bugs.debian.org (full text, mbox):

From: Johannes Schauer <j.schauer@email.de>
To: Nicolas Dandrimont <nicolas.dandrimont@crans.org>
Cc: 561046@bugs.debian.org, hector.oron@gmail.com
Subject: Re: ITP: gcc-arm -- The GNU C Compiler (cross-compiler for ARM targets)
Date: Wed, 29 Feb 2012 19:45:57 +0100
Hi,

this bugreport has been silent for a while.

Has there been an update since?

I have successfully compiled arm-none-eabi (baremetal) code for the
redbee econotag board using arm-linux-gnueabi-gcc from the emdebian
repositories.

I only needed to direct it to link with a different libc.a and libgcc.a
and then it compiled fine.

It would be nice to have those libraries apt-get-able in the emdebian
repositories or maybe even in main as gcc-avr is.

cheers, josch




Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org, hector.oron@gmail.com:
Bug#561046; Package wnpp. (Wed, 29 Feb 2012 19:57:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Hector Oron <hector.oron@gmail.com>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org, hector.oron@gmail.com. (Wed, 29 Feb 2012 19:57:04 GMT) Full text and rfc822 format available.

Message #73 received at 561046@bugs.debian.org (full text, mbox):

From: Hector Oron <hector.oron@gmail.com>
To: Johannes Schauer <j.schauer@email.de>
Cc: Nicolas Dandrimont <nicolas.dandrimont@crans.org>, 561046@bugs.debian.org
Subject: Re: ITP: gcc-arm -- The GNU C Compiler (cross-compiler for ARM targets)
Date: Wed, 29 Feb 2012 20:52:54 +0100
Hello Johannes,

2012/2/29 Johannes Schauer <j.schauer@email.de>:
> this bugreport has been silent for a while.
> Has there been an update since?

True, we have been waiting for multi-arch, so we can have multi-arch
based cross compilers.

> I have successfully compiled arm-none-eabi (baremetal) code for the
> redbee econotag board using arm-linux-gnueabi-gcc from the emdebian
> repositories.
>
> I only needed to direct it to link with a different libc.a and libgcc.a
> and then it compiled fine.

Not sure what you exactly mean here. Are you linking with newlib?

> It would be nice to have those libraries apt-get-able in the emdebian
> repositories or maybe even in main as gcc-avr is.

What libraries are you talking about?

Regards,
-- 
 Héctor Orón  -.. . -... .. .- -.   -.. . ...- . .-.. --- .--. . .-.




Changed Bug title to 'ITP: gcc-4.5-cross -- GNU Compiler Collection cross compilers (C, C++) for armel architecture' from 'RFP: gcc-arm -- The GNU C Compiler (cross-compiler for ARM targets)' Request was from Bart Martens <bartm@debian.org> to control@bugs.debian.org. (Tue, 12 Jun 2012 06:03:05 GMT) Full text and rfc822 format available.

Owner changed from hector.oron@gmail.com to Hector Oron <zumbi@debian.org>. Request was from Bart Martens <bartm@debian.org> to control@bugs.debian.org. (Tue, 12 Jun 2012 06:03:06 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org, Hector Oron <zumbi@debian.org>:
Bug#561046; Package wnpp. (Fri, 16 Aug 2013 17:03:59 GMT) Full text and rfc822 format available.

Acknowledgement sent to Lucas Nussbaum <lucas@debian.org>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org, Hector Oron <zumbi@debian.org>. (Fri, 16 Aug 2013 17:03:59 GMT) Full text and rfc822 format available.

Message #82 received at 561046@bugs.debian.org (full text, mbox):

From: Lucas Nussbaum <lucas@debian.org>
To: 561046@bugs.debian.org
Cc: control@bugs.debian.org
Subject: gcc-4.5-cross: changing back from ITP to RFP
Date: Fri, 16 Aug 2013 18:58:54 +0200
retitle 561046 RFP: gcc-4.5-cross -- GNU Compiler Collection cross compilers (C, C++) for armel architecture
noowner 561046
tag 561046 - pending
thanks

Hi,

A long time ago, you expressed interest in packaging gcc-4.5-cross. Unfortunately,
it seems that it did not happen. In Debian, we try not to keep ITP bugs open
for a too long time, as it might cause other prospective maintainers to
refrain from packaging the software.

This is an automatic email to change the status of gcc-4.5-cross back from ITP
(Intent to Package) to RFP (Request for Package), because this bug hasn't seen
any activity during the last 14 months.

If you are still interested in packaging gcc-4.5-cross, please send a mail to
<control@bugs.debian.org> with:

 retitle 561046 ITP: gcc-4.5-cross -- GNU Compiler Collection cross compilers (C, C++) for armel architecture
 owner 561046 !
 thanks

It is also a good idea to document your progress on this ITP from time to
time, by mailing <561046@bugs.debian.org>.  If you need guidance on how to
package this software, please reply to this email, and/or contact the
debian-mentors@lists.debian.org mailing list.

Thank you for your interest in Debian,
-- 
Lucas, for the QA team <debian-qa@lists.debian.org>



Changed Bug title to 'RFP: gcc-4.5-cross -- GNU Compiler Collection cross compilers (C, C++) for armel architecture' from 'ITP: gcc-4.5-cross -- GNU Compiler Collection cross compilers (C, C++) for armel architecture' Request was from Lucas Nussbaum <lucas@debian.org> to control@bugs.debian.org. (Fri, 16 Aug 2013 17:15:40 GMT) Full text and rfc822 format available.

Removed annotation that Bug was owned by Hector Oron <zumbi@debian.org>. Request was from Lucas Nussbaum <lucas@debian.org> to control@bugs.debian.org. (Fri, 16 Aug 2013 17:15:41 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 24 03:54:20 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.